image: docker:latest

services:
- docker:dind

stages:
- test
- build
- deploy

variables:
  IMAGE_TAG_ENTRYSOUND: monomo/entrysound_dir:$CI_PIPELINE_ID
  DOCKER_DRIVER: overlay2
  GO111MODULE: "on"
test:
  stage: test
  image: golang:1.12
  allow_failure: true
  script:
    - export GO111MODULE=on
    - go test ./...
sast:
  stage: test
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - export SAST_VERSION=${SP_VERSION:-$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')}
    - |
      docker run \
        --env SAST_ANALYZER_IMAGES \
        --env SAST_ANALYZER_IMAGE_PREFIX \
        --env SAST_ANALYZER_IMAGE_TAG \
        --env SAST_DEFAULT_ANALYZERS \
        --env SAST_BRAKEMAN_LEVEL \
        --env SAST_GOSEC_LEVEL \
        --env SAST_FLAWFINDER_LEVEL \
        --env SAST_DOCKER_CLIENT_NEGOTIATION_TIMEOUT \
        --env SAST_PULL_ANALYZER_IMAGE_TIMEOUT \
        --env SAST_RUN_ANALYZER_TIMEOUT \
        --env GO111MODULE=on \
        --volume "$PWD:/code" \
        --volume /var/run/docker.sock:/var/run/docker.sock \
        "registry.gitlab.com/gitlab-org/security-products/sast:$SAST_VERSION" /app/bin/run /code
  dependencies: []
  artifacts:
    reports:
      sast: gl-sast-report.json
build:
  stage: build
  script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
  - docker build -t $IMAGE_TAG_ENTRYSOUND .
  - docker push $IMAGE_TAG_ENTRYSOUND
  - echo $CI_PIPELINE_ID
deploy:
  stage: deploy
  allow_failure: false
  when: manual
  script:
  - docker run -e KUBE_DEPLOYER_URL=$KUBE_DEPLOYER_URL -e KUBE_DEPLOYER_AUTH=$KUBE_DEPLOYER_AUTH monomo/kube-deployer-client --namespace entrysound --name entrysound-dir --version $CI_PIPELINE_ID --tag $CI_PIPELINE_ID